import importlib.resources
import pickle

NAMES = (
'Євген', 'Євгеній', 'Євлампій', 'Євстафій', 'Єгор', 'Єремій', 'Іван', 'Ігор', 'Ізяслав', 'Іларіон', 'Ілля', 'Іоанн',
'Адам', 'Адріан', 'Адріян', 'Азар', 'Азарій', 'Алевтин', 'Альберт', 'Амвросій', 'Анастас', 'Анастасій', 'Анатолій',
'Андрон', 'Андрій', 'Антон', 'Антоній', 'Анісій', 'Аркадій', 'Арсен', 'Арсеній', 'Артем', 'Артур', 'Архип', 'Атанас',
'Афанасій', 'Благовіст', 'Благодар', 'Богдан', 'Богуслав', 'Божемир', 'Божен', 'Болеслав', 'Боримир', 'Боримисл',
'Борис', 'Борислав', 'Боронислав', 'Братислав', 'Братослав', 'Бронислав', 'Будимир', 'Будислав', 'Буйтур', 'Буревій',
'Буревіст', "В'ячеслав", 'Вадим', 'Вакула', 'Валентин', 'Валерій', 'Варфоломій', 'Василь', 'Велемир', 'Велемудр',
'Велет', 'Веремій', 'Вернислав', 'Вишеслав', 'Влад', 'Владислав', 'Власт', 'Вогнедар', 'Вогнян', 'Волелюб', 'Володар',
'Володимир', 'Володислав', 'Воротислав', 'Воїслав', 'Вратислав', 'Всевлад', 'Всеволод', 'Всеслав', 'Вукол', 'Віктор',
'Вір', 'Вірослав', 'Віталій', 'Вітан', 'Вітомир', 'Гаврило', 'Геннадій', 'Георгій', 'Герасим', 'Гліб', 'Гнат',
'Годомир', 'Гордислав', 'Гордомисл', 'Гордослав', 'Гордій', 'Горимир', 'Горимисл', 'Горисвіт', 'Горислав', 'Градимир',
'Градислав', 'Гранислав', 'Григорій', 'Давид', 'Далемил', 'Далемир', 'Данило', 'Данко', 'Даромир', 'Дарій', "Дем'ян",
'Демид', 'Денис', 'Дмитро', 'Добрик', 'Добриня', 'Добромир', 'Добромисл', 'Доморад', 'Домослав', 'Домінік', 'Дорогомир',
'Дорогомисл', 'Дорофій', 'Драган', 'Драгомир', 'Жадан', 'Ждан', 'Живослав', 'Захар', 'Захарій', 'Зборислав', 'Звенигор',
'Звенимир', 'Зиновій', 'Злат', 'Златан', 'Златомир', 'Златоус', 'Зореслав', 'Зорян', 'Зіновій', 'Кий', 'Кирило', 'Киян',
'Корнелій', 'Корнило', 'Корнилій', 'Корній', 'Костянтин', 'Кузьма', 'Курило', 'Кіндрат', 'Лаврентій', 'Лаврін',
'Ладимир', 'Ладислав', 'Ладолюб', 'Ладомир', 'Лев', 'Левко', 'Леонід', "Лук'ян", 'Лука', 'Любим', 'Любовир', 'Любодар',
'Любозар', 'Любомил', 'Любомир', 'Любомисл', 'Любослав', 'Людислав', 'Людомил', 'Лютобор', 'Лютомисл', 'Маврикій',
'Магадар', 'Магамир', 'Магаслав', 'Май', 'Макар', 'Максим', "Мар'ян", 'Марко', 'Маркіян', 'Мартин', 'Матвій', 'Медомир',
'Межамир', 'Мечислав', 'Микита', 'Микола', 'Милан', 'Милован', 'Милодар', 'Милослав', 'Мир', 'Миролюб', 'Мирон',
'Мирослав', 'Михайло', 'Мстислав', 'Мудролюб', 'Мусій', 'Надій', 'Назарій', 'Наслав', 'Нестор', 'Никифор', 'Никодим',
'Ничипор', 'Ничипір', 'Нікіта', 'Олег', 'Олекса', 'Олександр', 'Олексій', 'Олесь', 'Омелян', 'Ондрій', 'Онтін',
'Онуфрій', 'Онісій', 'Опанас', 'Орест', 'Орхип', 'Остап', 'Остромир', 'Остромисл', 'Остромов', 'Охрім', "П'єр", 'Павло',
'Панас', 'Пантелеймон', 'Перелюб', 'Перемил', 'Перемисл', 'Пересвіт', 'Переяслав', 'Першик', 'Петро', 'Пилип', 'Пимен',
'Пимон', 'Пимін', 'Порфир', 'Потап', 'Рава', 'Рад', 'Радан', 'Радимир', 'Радован', 'Радомир', 'Радомисл', 'Радослав',
'Ратибор', 'Ратимир', 'Рафаїл', 'Родослав', 'Родіон', 'Роксолан', 'Роман', 'Ростислав', 'Русан', 'Руслан', 'Сармат',
'Свирид', 'Святовид', 'Святогор', 'Святолюб', 'Святополк', 'Святослав', 'Святояр', 'Світлан', 'Світлогор', 'Світогор',
'Світодар', 'Світозар', 'Світолюб', 'Світослав', 'Світояр', 'Северин', 'Семен', 'Серафим', 'Сергій', 'Сидор', 'Сидір',
'Силослав', 'Синьоок', 'Слава', 'Славомир', 'Сновид', 'Снозір', 'Сніжан', 'Спас', 'Станимир', 'Станислав', 'Стародум',
'Степан', 'Стефаній', 'Стожар', 'Судислав', 'Тарас', 'Тарослав', 'Твердислав', 'Творислав', 'Теодозій', 'Терентій',
'Тимофій', 'Тимур', 'Тихомир', 'Тихон', 'Толислав', 'Тригост', 'Тімох', 'Улас', 'Уличан', 'Устим', 'Фауст', 'Федор',
'Федір', 'Флор', 'Фрол', 'Хвалимир', 'Ходота', 'Хорив', 'Хотимир', 'Христофор', 'Чара', 'Чеслав', 'Честислав', 'Щек',
'Юліан', 'Юлій', 'Юрій', 'Юхим', 'Яволод', 'Явір', 'Яків', 'Ян', 'Яр', 'Ярема', 'Ярило', 'Яромисл', 'Ярополк',
'Яросвіт', 'Ярослав', 'Ясновид', 'Ясногор', 'Яснозір', 'Яснолик')

FEMALE_NAMES = (
'Єва', 'Євгенія', 'Євдокія', 'Євфросинія', 'Єкатерина', 'Єлизавета', 'Єпистима', 'Єпистимія', 'Єфросинія', 'Іванна',
'Ігорина', 'Іларія', 'Ілона', 'Інга', 'Інеса', 'Інна', 'Ірина', 'Ірма', 'Ісидора', 'Ія', 'Ївга', 'Августа', 'Аврелія',
'Аврора', 'Агапія', 'Агата', 'Агафоника', 'Агафія', 'Аглая', 'Аглаїда', 'Агнеса', 'Агнія', 'Агрипина', 'Ада',
'Аделаїда', 'Аделіна', 'Адріана', 'Аеліта', 'Аза', 'Азалія', 'Акилина', 'Аксенія', 'Алевтина', 'Алла', 'Альбертина',
'Альбертіна', 'Альбіна', 'Альвіна', 'Альфреда', 'Аліна', 'Аліса', 'Анастасія', 'Анатолія', 'Ангеліна', 'Анжела',
'Анжеліка', 'Анна', 'Антонида', 'Антоніна', 'Антонія', 'Анфіса', 'Аполлонія', 'Аполлінарія', 'Аркадія', 'Арсена',
'Арсенія', 'Артеміза', 'Артемізія', 'Артемісія', 'Артемія', 'Аріадна', 'Аскліпія', 'Ася', 'Атена', 'Аурика', 'Афанасія',
'Афродіта', 'Афіна', 'Аїда', 'Бажана', 'Барбара', 'Беатриса', 'Белла', 'Берта', 'Богдана', 'Богуслава', 'Божена',
'Болеслава', 'Борислава', "В'ячеслава", 'Валентина', 'Валерія', 'Ванда', 'Варвара', 'Василина', 'Васса', 'Векла',
'Венера', 'Вероніка', 'Влада', 'Владислава', 'Владлена', 'Власта', 'Володимира', 'Всеслава', 'Вікторина', 'Вікторія',
'Вілена', 'Віленіна', 'Віліна', 'Віола', 'Віолетта', 'Віра', 'Віргінія', 'Віринея', 'Віта', 'Віталіна', 'Віталія',
'Галина', 'Ганна', 'Гафія', 'Гаїна', 'Гелена', 'Георгіна', 'Гертруда', 'Глафира', 'Глафіра', 'Гликерія', 'Горпина',
'Густава', 'Дана', 'Дарина', 'Дарія', 'Дзвенислава', 'Дзвінка', 'Домаха', 'Домна', 'Домініка', 'Донна', 'Доротея',
'Дорофея', 'Діана', 'Діна', 'Евеліна', 'Едіта', 'Елвіна', 'Елеонора', 'Елла', 'Ельвіра', 'Емма', 'Еммануель',
'Еммануїла', 'Емілія', 'Еріка', 'Есмеральда', 'Естер', 'Есфір', 'Жадана', 'Жанна', 'Ждана', 'Жозефіна', 'Звенислава',
'Звонимира', 'Земфіра', 'Злата', 'Зореслава', 'Зоря', 'Зоряна', 'Зоя', 'Зінаїда', 'Зірка', 'Йосипа', 'Йосифата',
'Казимира', 'Калина', 'Камілла', 'Капитолина', 'Капитоліна', 'Капітоліна', 'Карина', 'Кароліна', 'Кассандра',
'Катерина', 'Катря', 'Квітка', 'Кикилія', 'Килина', 'Клавдія', 'Клара', 'Клеопатра', 'Констанція', 'Кора', 'Корина',
'Корнелія', 'Ксенія', 'Кіра', 'Лада', 'Лариса', 'Леля', 'Леся', 'Либідь', 'Ликера', 'Ликерія', 'Лисавета', 'Лола',
'Лоліта', 'Лукина', 'Лукреція', 'Лукія', 'Любов', 'Любомира', 'Людмила', 'Лідія', 'Лілея', 'Лілія', 'Ліна', 'Мавка',
'Магда', 'Магдалена', 'Магдалина', 'Майя', 'Макрина', 'Малуша', 'Мальва', 'Мальвіна', "Мар'я", "Мар'яна", 'Маргарита',
'Марина', 'Марта', 'Мартина', 'Мартіна', 'Марфа', 'Маріамна', 'Маріанна', 'Марічка', 'Марія', 'Матрона', 'Меланія',
'Мелітина', 'Мечислава', 'Милана', 'Мирослава', 'Михайлина', 'Млада', 'Мокрина', 'Моніка', 'Мотрона', 'Мотря',
'Мстислава', 'Надія', 'Найда', 'Найдена', 'Настасія', 'Настя', 'Наталка', 'Наталя', 'Наталія', 'Неля', 'Нонна', 'Ніка',
'Ніна', 'Нінель', 'Одарина', 'Одарка', 'Оксана', 'Оксенія', 'Октавія', 'Олександра', 'Олена', 'Олеся', 'Ольга',
'Олівія', 'Олімпіада', 'Олімпія', 'Ореста', 'Орина', 'Орися', 'Осипа', 'Пава', 'Павла', 'Павлина', 'Палагна', 'Палазга',
'Параскева', 'Параскевія', 'Парасковія', 'Пелагея', 'Пелагія', 'Пистина', 'Поліна', 'Пріська', 'Пульхера', 'Пульхерія',
'Рада', 'Радимира', 'Радмила', 'Радогоста', 'Радомира', 'Радослава', 'Ракель', 'Рахель', 'Рахіль', 'Раїна', 'Раїса',
'Ребекка', 'Ревека', 'Регіна', 'Рената', 'Римма', 'Рогволода', 'Рогнеда', 'Рогніда', 'Родослава', 'Рожана', 'Роза',
'Розалія', 'Роксана', 'Роксолана', 'Романа', 'Романна', 'Романія', 'Ростислава', 'Рошель', 'Рузалія', 'Руслана',
'Русудан', 'Русудана', 'Рут', 'Руф', 'Руфина', 'Руфіна', 'Ріана', 'Ріанна', 'Сабріна', 'Санта', 'Сара', 'Сарра',
'Святогора', 'Святослава', 'Світлана', 'Світозара', 'Світояра', 'Севастіана', 'Северина', 'Секлета', 'Секлетина',
'Серафима', 'Синезора', 'Слава', 'Сніжана', 'Соломія', 'Соня', 'Сосанна', 'Софія', 'Станіслава', 'Стелла', 'Стефанида',
'Стефанія', 'Судислава', 'Сусанна', 'Сюзанна', 'Сільвія', 'Сімона', 'Тава', 'Тамара', 'Таїса', 'Таїсія', 'Текля',
'Теодозія', 'Тереза', 'Тетяна', 'Тодора', 'Трояна', 'Тіна', 'Уляна', 'Фаїна', 'Февронія', 'Февросія', 'Федора',
'Федосія', 'Фекла', 'Фелікса', 'Феліція', 'Феодора', 'Феодосія', 'Филікитата', 'Филіцата', 'Филіцитата', 'Фота',
'Фотина', 'Фотинія', 'Харита', 'Харитина', 'Харитя', 'Хотина', 'Хриса', 'Христина', 'Христя', 'Хівря', 'Цветана',
'Цвітана', 'Цецилія', 'Цецілія', 'Чеслава', 'Чухрія', 'Югина', 'Юдит', 'Юдита', 'Юдиф', 'Юзефа', 'Юлина', 'Юліана',
'Юліанна', 'Юліанія', 'Юлія', 'Юнія', 'Юстина', 'Юхимина', 'Юхимія', 'Явдоха', 'Ядвіга', 'Яна', 'Яніна', 'Ярина',
'Яромира', 'Ярослава')

file_path = 'family-names.pkl'
with importlib.resources.open_binary('lesya.language.data', file_path) as f:
    lines = pickle.load(f)

LASTNAME_ENDINGS2 = {l[-2:] for l in lines}
LASTNAME_ENDINGS3 = {l[-3:] for l in lines if len(l) > 4}
LASTNAME_ENDINGS4 = {l[-4:] for l in lines if len(l) > 6}
